/***************************************************************************
                          matrix.h  -  description
                             -------------------
    begin                : Wed Mar 6 2002
    copyright            : (C) 2002 by Jrgen Bhm
    email                : aviduratas@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it.                                                                    *
 *                                                                         *
 ***************************************************************************/

#ifndef MATRIX_H
#define MATRIX_H

#include <GL/glu.h>

#include <math.h>



class Point {

	public:

	Point () : x ( 0 ), y( 0 ), z ( 0 ) {};

	Point ( GLfloat xx, GLfloat yy, GLfloat zz ): x(xx), y(yy), z(zz) {};

	GLfloat xval () { return x;};
	
	GLfloat yval () { return y;};
	
	GLfloat zval () { return z;};
		
	GLfloat x, y, z;

};


template<class T>
class matrix {

	public:

	matrix ();
	
	~matrix ();
	
	void initmatrix ( int m, int n );
		
	T & operator() (int i, int j);
	
	int rows () { return mm; }
	
	int cols () { return nn; };
	
	bool active () { return arrp; };
	

	private:
	
	int mm, nn;
	
	T * arrp;
		
};


template<class T>
matrix<T>::matrix () : mm(0), nn(0), arrp (0) {

}



template<class T>
void matrix<T>::initmatrix (int m, int n ) {

if (arrp)
	delete [] arrp;

mm = m;
nn = n;

arrp = new T[m*n];

}

template<class T>
matrix<T>::~matrix () {

if (arrp)
	delete [] arrp;

}

template<class T>
T & matrix<T>::operator()( int i, int j ) {

return *(arrp+nn*i+j);

}



void cross ( Point a, Point b, Point c, Point & d );

void crossnorm ( Point a, Point b, Point c, Point & d );

GLfloat dotprod ( Point a, Point b );


void vecminus ( Point a, Point b, Point & c );

void vecplus ( Point a, Point b, Point & c );

void scalmult ( GLfloat l, Point & a );

#endif



