/***************************************************************************
                          surfxpdoc.cpp  -  description
                             -------------------
    begin                : Die M�  5 19:59:18 CET 2002
    copyright            : (C) 2002 by Jrgen B�m
    email                : aviduratas@gmx.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it.                                                                   *
 *                                                                         *
 ***************************************************************************/

#include "surfxpdoc.h"

#include <fstream>

using namespace std;

SurfxpDoc::SurfxpDoc()
{
  modified = false;
}

SurfxpDoc::~SurfxpDoc()
{
}

void SurfxpDoc::newDoc()
{
}

bool SurfxpDoc::save()
{
  return true;
}

bool SurfxpDoc::saveAs(const QString &filename)
{
  return true;
}


void compnormal4 ( Point a, Point P1, Point P2, Point P3, Point P4, Point & d ) {

Point d1, d2, d3, dd;

crossnorm ( a, P1, P2, d1 );
crossnorm ( a, P2, P3, d2 );
crossnorm ( a, P3, P4, d3 );

vecplus ( d1, d2, dd );
vecplus ( dd, d3, dd );

GLfloat lengthd = sqrt ( dotprod ( dd, dd ) );
			
if (lengthd > 0 ) {
			scalmult ( 1/lengthd, dd );
};

d = dd;

};

void compnormal3 ( Point a, Point P1, Point P2, Point P3, Point & d ) {

Point d1, d2, dd;

crossnorm ( a, P1, P2, d1 );
crossnorm ( a, P2, P3, d2 );

vecplus ( d1, d2, dd );

GLfloat lengthd = sqrt ( dotprod ( dd, dd ) );
			
if (abs ( lengthd ) > 0 ) {
			scalmult ( 1/lengthd, dd );
};

d = dd;

};

void compnormal2 ( Point a, Point P1, Point P2, Point & d ) {

Point dd;

crossnorm ( a, P1, P2, dd );

d = dd;

};



bool SurfxpDoc::load(const QString &filename)
{

	ifstream infile ( filename.toLatin1 () );
	
	int m, n;
	
	infile >> m;
	
	infile >> n;
	
	grid.initmatrix ( n, m );
	
	gridnormal.initmatrix ( n, m );
	
	double x, y, z;
	
	for (int i = 0; i < n; i++ ) {
	
		for ( int j = 0; j < m; j++ ) {
		
			infile >> x;
			
			infile >> y;
			
			infile >> z;
			
			grid (i,j) = Point ( x, y, z );
			
		};
		
	};
	
	
	for ( int i = 1; i < n-1; i++ ) {
	
		for ( int j = 1; j < m-1; j++ ) {
		
			Point d1, d2, d3, d4, d5, d6;
			
			crossnorm ( grid ( i, j ), grid (i-1, j+1 ), grid ( i-1, j ), d1 );
			crossnorm ( grid ( i, j ), grid ( i-1, j ), grid ( i, j-1 ), d2 );
			crossnorm ( grid ( i, j ), grid ( i, j-1 ), grid ( i+1 , j-1 ), d3 );
			crossnorm ( grid ( i, j ), grid ( i+1, j-1), grid ( i+1, j ), d4 );
			crossnorm ( grid ( i, j ), grid ( i+1, j ), grid ( i, j+1 ), d5 );
			crossnorm ( grid ( i, j ), grid ( i, j+1 ), grid ( i-1, j+1 ), d6 );
			
			Point d ( 0, 0, 0);
			
			vecplus ( d1, d2, d );
			vecplus ( d, d3, d );
			vecplus ( d, d4, d );
			vecplus ( d, d5, d );
			vecplus ( d, d6, d );
			
			GLfloat lengthd = sqrt ( dotprod ( d, d ) );
			
			if ( lengthd > 0 ) {
			
				scalmult ( 1/lengthd, d );
				
			};
								
			gridnormal ( i,j ) = d;
			
		};
		
	};
	
	
	for ( int i = 1; i < n-1; i++ ) {
	
		Point d;
	
		compnormal4 ( grid (i, 0), grid ( i+1, 0 ), grid ( i, 1 ), grid (i-1, 1 ),
									grid ( i-1, 0 ), d );
	
	
		gridnormal ( i, 0 ) = d;
		
		
		compnormal4 ( grid ( i, m-1 ), grid ( i-1, m-1 ), grid ( i, m-2 ), grid ( i+1, m-2 ),
									grid ( i+1, m-1), d );
									
		gridnormal ( i, m-1 ) = d;
		
	};
	
	for ( int j = 1; j < m-1; j++ ) {
	
		Point d;
		
		compnormal4 ( grid ( 0, j ), grid ( 0, j-1 ), grid ( 1, j-1 ), grid ( 1, j),
									grid ( 0, j+1 ), d );
									
		gridnormal ( 0, j ) = d;
		
		compnormal4 ( grid ( n-1, j ), grid ( n-1, j+1 ), grid ( n-2, j+1 ), grid ( n-2, j ),
									grid ( n-1, j-1 ), d );
									
		gridnormal ( n-1, j ) = d;
		
	};
	
	Point d;
	
	compnormal2 ( grid ( 0, 0 ), grid ( 1, 0 ), grid ( 0, 1 ), d );
	
	gridnormal ( 0, 0 ) = d;
	
	compnormal3 ( grid ( 0, m-1 ), grid ( 0, m-2 ), grid ( 1, m-2 ), grid ( 1, m-1 ), d );
	
	gridnormal ( 0, m-1 ) = d;
	
	compnormal3 ( grid ( n-1, 0 ), grid ( n-1, 1 ), grid ( n-2, 1 ), grid ( n-2, 0 ), d );
	
	gridnormal ( n-1, 0 ) = d;
	
	compnormal2 ( grid ( n-1, m-1 ), grid ( n-2, m-1 ), grid ( n-1, m-2 ), d );
	
	gridnormal ( n-1, m-1 ) = d;  		
		
  emit documentChanged();
  return true;
}

bool SurfxpDoc::isModified() const
{
  return modified;
}
